//#include "Processing_message.h"
#include "../Processing_Message/Processing_message.h"

void  goalCallback(const geometry_msgs::PoseStamped::ConstPtr& msg)
{
	//填充数据

	double x=msg->pose.position.x;
	double y=msg->pose.position.y;
	double z=msg->pose.position.z;
	double qx=msg->pose.orientation.x;
	double qy=msg->pose.orientation.y;
	double qz=msg->pose.orientation.z;
	double qw=msg->pose.orientation.w;

	std::cout<<"  post goal "<<qx<<","<<qy<<","<<qz<<","<<qw<<std::endl;
	double theta=acos(qw)*2.0;
	theta=(qz>0)?theta:-theta;

	message::Goal_msg goal;
	message::Base_info base_info;
	base_info.set_sender(message::eEmpty);
	base_info.set_receiver(message::eAGV);
	base_info.set_msg_type(message::eGoal_msg);
	goal.mutable_base_info()->CopyFrom(base_info);

	goal.set_x(x);
	goal.set_y(y);
	goal.set_theta(theta);

	std::cout<<Processing_message::get_instance_references().get_socket().send(goal.SerializeAsString())<<std::endl;//发送数据
}

int main(int argc,char** argv)
{
//"tcp://192.168.2.183:30001"
	ros::init(argc, argv, "test_node");
	Processing_message& t_processing_message=Processing_message::get_instance_references();//获取单例
	ros::Subscriber subscriber=t_processing_message.get_nodehandele().subscribe("/move_base_simple/goal",1,goalCallback);//订阅话题

	t_processing_message.Processing_message_init("tcp://192.168.2.182:30001");//默认为连接
	ros::spin();
	t_processing_message.Processing_message_uninit();
}
